<template>
    <div class="sidebar-wrapper">
        <tracker />
        <ad-place v-if="rightBanners.length && rightBanners[0]" :banner="rightBanners[0]" />
        <standings v-if="isLeaguePage" />
        <ad-place v-if="rightBanners.length && rightBanners[1]" :banner="rightBanners[1]" />

        <events
            v-if="topEvents !== null && topEvents !== undefined && Object.getOwnPropertyNames(topEvents).length"
            :events="sortedTopEvents"
            :loading="eventsLoading"
        />

        <ad-place v-if="rightBanners.length && rightBanners[2]" :banner="rightBanners[2]" />
    </div>
</template>

<script>
import Tracker from './Tracker'
import Standings from './Standings'
import Events from './Events'
import AdPlace from './AdPlace'
import {mapActions, mapGetters} from 'vuex'
export default {
    name: 'SidebarRight',
    computed: {
        ...mapGetters(['topEvents']),
        isLeaguePage() {
            return this.$route.name && this.$route.name.split('.')[1] === 'league'
        }
    },
    data() {
        return {
            rightBanners: {},
            eventsLoading: true,
            events: [
                {
                    teams: [
                        { name: 'Everton', 'logo': '/img/team1.png' },
                        { name: 'West Ham', 'logo': '/img/team2.png' }
                    ],
                    time: '23:00'
                },
                {
                    teams: [
                        { name: 'Everton', 'logo': '/img/team1.png' },
                        { name: 'West Ham', 'logo': '/img/team2.png' }
                    ],
                    time: '20:00'
                },
                {
                    teams: [
                        { name: 'Everton', 'logo': '/img/team1.png' },
                        { name: 'West Ham', 'logo': '/img/team2.png' }
                    ],
                    time: '17:00'
                },
                {
                    teams: [
                        { name: 'Everton', 'logo': '/img/team1.png' },
                        { name: 'West Ham', 'logo': '/img/team2.png' }
                    ],
                    time: '14:00'
                },
                {
                    teams: [
                        { name: 'Everton', 'logo': '/img/team1.png' },
                        { name: 'West Ham', 'logo': '/img/team2.png' }
                    ],
                    time: '09:00'
                }
            ],
            sortedTopEvents: []
        }
    },
    methods: {
        ...mapActions(['fetchTopEvents']),
    },
    mounted() {
        this.eventsLoading = true
        this.fetchTopEvents().finally(() => {
            this.eventsLoading = false
            this.sortedTopEvents = _.orderBy(this.topEvents, ['event.fixture.start_date'],'asc');

            this.$forceUpdate()
            this.$log.debug('this.topEvents', this.topEvents)
        })

        this.$root.$on('getBanners', (banners) => {
            if (banners.right.length) {
                this.rightBanners = banners.right
                this.$forceUpdate()
                this.$log.debug('rightBanners', this.rightBanners)
            }
        })
    },
    components: {
        AdPlace,
        Tracker,
        Standings,
        Events
    },
}
</script>
